js> var A = function() { this.x = "x"; }
js> a = new A()
[object Object]
js> A.prototype.print = function () { print(this.x); }
function () {
    print(this.x);
}
js> var B = function() { this.y = "y"; }
js> B.prototype = new A()
[object Object]
js> B.prototype.print = function() { print(this.y); }
function () {
    print(this.y);
}
js> b = new B()
[object Object]
js> a.print()
x
js> b.print()
y
js> var Super = function(owner, sup) {
   for(var fn in sup.prototype) {
      if(sup.prototype.hasOwnProperty(fn) &&
         sup.prototype[fn] instanceof Function) {
         this[fn] =
            (function(v) {
               return function() { sup.prototype[v].apply(owner, arguments); };
             })(fn);
      }
   }
};
js> print(x)
typein:21: ReferenceError: x is not defined
js> print(a)
[object Object]
js> b.$super = new Super(b, A)
[object Object]
js> b.$super.print()
x
js> b.print()
y
js>